unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ChessBrd, StdCtrls, Spin, ExtCtrls, ComCtrls, shellapi;

type
  TformMenuPrincipal = class(TForm)
    tab: TPageControl;
    tabPartida: TTabSheet;
    tabOpciones: TTabSheet;
    ChessBrd1: TChessBrd;
    ImageCm36: TImage;
    ImageFr40: TImage;
    ButtonBack: TButton;
    ButtonStop: TButton;
    ButtonForward: TButton;
    ButtonMove: TButton;
    Buttonnew: TButton;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    TabSheet1: TTabSheet;
    GroupBox1: TGroupBox;
    CheckBoxWhiteOnTop: TCheckBox;
    CheckBoxCoords: TCheckBox;
    CheckBoxLines: TCheckBox;
    Label2: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Label4: TLabel;
    Label3: TLabel;
    SpinEdit1: TSpinEdit;
    Panel1: TPanel;
    LWEB: TLabel;
    meAcciones: TMemo;
    Label5: TLabel;
    ListBox1: TListBox;
    procedure ButtonBackClick(Sender: TObject);
    procedure ButtonForwardClick(Sender: TObject);
    procedure ButtonMoveClick(Sender: TObject);
    procedure ButtonNewClick(Sender: TObject);
    procedure ButtonStopClick(Sender: TObject);
    procedure CheckBoxCoordsClick(Sender: TObject);
    procedure CheckBoxLinesClick(Sender: TObject);
    procedure CheckBoxWhiteOnTopClick(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure RadioGroup2Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure ChessBrd1CalculateMove(Sender: TObject; var oldsq,
  newsq: Square);
    procedure ChessBrd1CalculationFailed(Sender: TObject; oldSq,
  newSq: Square);
    procedure ChessBrd1Draw(Sender: TObject);
    procedure ChessBrd1LegalMove(Sender: TObject; oldSq, newSq: Square);
    procedure ChessBrd1Mate(Sender: TObject; oldSq, newSq: Square);
    procedure UpdateListBox;
    procedure LWEBClick(Sender: TObject);
    procedure ChessBrd1StaleMate(Sender: TObject; oldSq, newSq: Square);
    procedure ChessBrd1IllegalMove(Sender: TObject; square: Square);
    procedure ChessBrd1NoMatingMaterial(Sender: TObject);
    procedure ChessBrd1ThreefoldPosition(Sender: TObject);
    procedure ChessBrd1Promotion(Sender: TObject; oldSq, newSq: Square;
      var NewPiece: Char);
    procedure ChessBrd1Capture(Sender: TObject; oldSq, newSq: Square;
      CapturedPiece: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.dfm}

procedure TformMenuPrincipal.UpdateListBox;
var
    list: TStringList;
begin
    list := TStringList.Create;
    Chessbrd1.GetMoveList(list);
    ListBox1.Items := list;
    list.Free;
end;


procedure TformMenuPrincipal.ButtonBackClick(Sender: TObject);
begin
     Chessbrd1.MoveBackward;
     UpdateListBox;
end;

procedure TformMenuPrincipal.ButtonForwardClick(Sender: TObject);
begin
    Chessbrd1.MoveForward;
    UpdateListBox;
end;

procedure TformMenuPrincipal.ButtonMoveClick(Sender: TObject);
begin
    Chessbrd1.Think;
end;

procedure TformMenuPrincipal.ButtonNewClick(Sender: TObject);
begin
  meAcciones.Lines.Append(DateTimeToStr(Now) + ' - Iniciada nueva partida');
    Chessbrd1.NewGame;
    UpdateListBox;
end;

procedure TformMenuPrincipal.ButtonStopClick(Sender: TObject);
begin
    Chessbrd1.CancelThinking;
end;

procedure TformMenuPrincipal.CheckBoxCoordsClick(Sender: TObject);
var
    cset: CoordSet;
begin
    if (CheckBoxCoords.Checked) then
    begin
        Include (cset,North);
        Include (cset,East);
        Include (cset,West);
        Include (cset,South);
    end
    else
    begin
        Exclude (cset,North);
        Exclude (cset,East);
        Exclude (cset,West);
        Exclude (cset,South);
    end;
    Chessbrd1.DisplayCoords:=cset;
end;

procedure TformMenuPrincipal.CheckBoxLinesClick(Sender: TObject);
begin
    Chessbrd1.BoardLines:=CheckBoxLines.Checked;
end;

procedure TformMenuPrincipal.CheckBoxWhiteOnTopClick(Sender: TObject);
var
    v: Integer;
begin
  Chessbrd1.WhiteOnTop:=CheckBoxWhiteOnTop.Checked;
  v:=RadioGroup1.Top;
  RadioGroup1.Top:=RadioGroup2.Top;
  RadioGroup2.Top:=v;
end;

procedure TformMenuPrincipal.ComboBox1Change(Sender: TObject);
begin
  case ComboBox1.ItemIndex of
    0 : Chessbrd1.CustomPieceSet := nil;
    1 : Chessbrd1.CustomPieceSet := ImageFr40.Picture.Bitmap;
    2 : Chessbrd1.CustomPieceSet := ImageCm36.Picture.Bitmap;
  end;
end;

procedure TformMenuPrincipal.ComboBox2Change(Sender: TObject);
begin
  Chessbrd1.CustomEngine := (comboBox2.ItemIndex = 1);
end;

procedure TformMenuPrincipal.ListBox1Click(Sender: TObject);
begin
  Chessbrd1.GotoMove(1+(ListBox1.ItemIndex+1) shr 1,((ListBox1.ItemIndex+1) mod 2)= 0);
end;


procedure TformMenuPrincipal.RadioGroup1Click(Sender: TObject);
begin
  Chessbrd1.ComputerPlaysBlack := Boolean(RadioGroup1.ItemIndex);
end;

procedure TformMenuPrincipal.RadioGroup2Click(Sender: TObject);
begin
  Chessbrd1.ComputerPlaysWhite := Boolean(RadioGroup2.ItemIndex);
end;

procedure TformMenuPrincipal.SpinEdit1Change(Sender: TObject);
begin
  Chessbrd1.SearchDepth := SpinEdit1.value;
end;

procedure TformMenuPrincipal.ChessBrd1CalculateMove(Sender: TObject; var oldsq,
  newsq: Square);
begin
    while (Chessbrd1.moveIsLegal(oldsq,newsq)=FALSE) do
    begin
        oldSq:=Square(random(65));
        newSq:=Square(random(65));
    end;
end;

procedure TformMenuPrincipal.ChessBrd1CalculationFailed(Sender: TObject; oldSq,
  newSq: Square);
begin
//
end;

procedure TformMenuPrincipal.ChessBrd1Draw(Sender: TObject);
begin
  if MessageDlg('Finalizacin de partida por "Draw" (sorteo). ' +
      'Partida finalizada. Desea iniciar una nueva partida?',
      mtInformation, [mbyes, mbno], 0) = mryes then
    Chessbrd1.NewGame;
end;

procedure TformMenuPrincipal.ChessBrd1LegalMove(Sender: TObject; oldSq, newSq: Square);
begin
  meAcciones.Lines.Append(DateTimeToStr(Now) + ' - Movimiento legal');
  UpdateListBox;
end;

procedure TformMenuPrincipal.ChessBrd1Mate(Sender: TObject; oldSq, newSq: Square);
begin
  meAcciones.Lines.Append(DateTimeToStr(Now) + ' - Jake mate. Partida finalizada.');
  if MessageDlg('Jake Mate!! Partida finalizada. Desea iniciar una nueva partida?',
      mtInformation, [mbyes, mbno],0) = mryes then
    Chessbrd1.NewGame;
end;

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.ChessBrd1StaleMate(Sender: TObject; oldSq,
  newSq: Square);
begin
  meAcciones.Lines.Append(DateTimeToStr(Now) + ' - Tablas - Fin de la partida');
  if MessageDlg('Se han producido tablas. Partida finalizada. Desea iniciar una nueva partida?',
      mtInformation, [mbyes, mbno],0) = mryes then
    Chessbrd1.NewGame;
end;

procedure TformMenuPrincipal.ChessBrd1IllegalMove(Sender: TObject;
  square: Square);
begin
  meAcciones.Lines.Append(DateTimeToStr(Now) + ' - Movimiento ilegal');
end;

procedure TformMenuPrincipal.ChessBrd1NoMatingMaterial(Sender: TObject);
begin
  meAcciones.Lines.Append(DateTimeToStr(Now) + ' - No es posible el Jake mate');
end;

procedure TformMenuPrincipal.ChessBrd1ThreefoldPosition(Sender: TObject);
begin
  meAcciones.Lines.Append(DateTimeToStr(Now) + ' - Triple repeticin - Posibilidad de tablas');
end;

procedure TformMenuPrincipal.ChessBrd1Promotion(Sender: TObject; oldSq,
  newSq: Square; var NewPiece: Char);
begin
  meAcciones.Lines.Append(DateTimeToStr(Now) + ' - Promocin - Nueva pieza: ' + NewPiece);
end;

procedure TformMenuPrincipal.ChessBrd1Capture(Sender: TObject; oldSq,
  newSq: Square; CapturedPiece: Char);
begin
  meAcciones.Lines.Append(DateTimeToStr(Now) + ' - Pieza eliminada: ' + CapturedPiece);
end;

end.
